Denial2 = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Denial2")

Denial2:RegisterDB("Denial2DB")
Denial2:RegisterDefaults('profile', {
	me = true,
	player = true,
	message = L["Your request has been canceled."],
	count = 0,
	gos = {
		banker = true,
		vendor = true,
		taxi = true,
		battlemaster = true,
		trainer = false,
		healer = false,
		inn = false,
		all = false
	},
	block = {}
})

function Denial2:OnInitialize()
	local options = {
		desc = L["Denied!"],
		type = "group",
		args = {
			player = {
				name = "player",
				desc = L["Toggles Cancel-Message to the requesting player on/off."],
				type = "toggle",
				get = function() return self.db.profile.player end,
				set = function(val) self.db.profile.player = val end,
			},
			me = {
				name = "me",
				desc = L["Toggles Chat Informations on/off"],
				type = "toggle",
				get = function() return self.db.profile.me end,
				set = function(val) self.db.profile.me = val end,
			},
			msg = {
				name = "msg",
				desc = L["Changes Message-Text that will be send to the requesting Player."],
				type = "text",
				usage = "<message>",
				get = function() return self.db.profile.message end,
				set = function(val) self.db.profile.message = val end,
				validate = function(val) return string.find(val, "^%w+$") end,
			},
			block = {
				name = "block",
				desc = L["Blocks several actions."],
				type = "group",
				args = {
					party = {
						name = "party",
						desc = L["Toggles denying of Party-Requests on/off."],
						type = "toggle",
						get = function() return self.db.profile.block.party end,
						set = function(val)
							self.db.profile.block.party = val
							self:OnEnable()
						end,
					},
					duel = {
						name = "duel",
						desc = L["Toggles denying of Dual-Requests on/off."],
						type = "toggle",
						get = function() return self.db.profile.block.duel end,
						set = function(val)
							self.db.profile.block.duel = val
							self:OnEnable()
						end,
					},
					ginv = {
						name = "ginv",
						desc = L["Toggles denying of Guild Invitations on/off."],
						type = "toggle",
						get = function() return self.db.profile.block.ginv end,
						set = function(val)
							self.db.profile.block.ginv = val
							self:OnEnable()
						end,
					},
					pet = {
						name = "pet",
						desc = L["Toggles denying of Petitions on/off."],
						type = "toggle",
						get = function() return self.db.profile.block.pet end,
						set = function(val)
							self.db.profile.block.pet = val
							self:OnEnable()
						end,
					},
					trade = {
						name = "trade",
						desc = L["Toggles denying of Trades on/off."],
						type = "toggle",
						get = function() return self.db.profile.block.trade end,
						set = function(val)
							self.db.profile.block.trade = val
							self:OnEnable()
						end,
					},
					all = {
						name = "all",
						desc = L["Toggles blocking of all Actions on/off."],
						type = "toggle",
						get = function() return self.db.profile.block.all end,
						set = function(val)
							self.db.profile.block.all = val
							self:OnEnable()
						end,
					},
				}
			},
			skip = {
				name = "skip",
				desc = L["Toggles Gossips on/off."],
				type = "group",
				args = {
					bank = {
						name = "bank",
						desc = L["Toggles banker gossip on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.bank end,
						set = function(val) self.db.profile.gos.bank = val end,
					},
					vendor = {
						name = "vendor",
						desc = L["Toggles vendor gossip on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.vendor end,
						set = function(val) self.db.profile.gos.vendor = val end,
					},
					taxi = {
						name = "taxi",
						desc = L["Toggles taxi gossip on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.taxi end,
						set = function(val) self.db.profile.gos.taxi = val end,
					},
					trainer = {
						name = "trainer",
						desc = L["Toggles trainer gossip on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.trainer end,
						set = function(val) self.db.profile.gos.trainer = val end,
					},
					inn = {
						name = "inn",
						desc = L["Toggles inn gossip on/off. (Turn this off if you have problems with Innkeepers that also act as Vendors.)"],
						type = "toggle",
						get = function() return self.db.profile.gos.inn end,
						set = function(val) self.db.profile.gos.inn = val end,
					},
					healer = {
						name= "healer",
						desc = L["Toggles healer gossip on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.healer end,
						set = function(val) self.db.profile.gos.healer = val end,
					},
					battle = {
						name = "battle",
						desc = L["Toggles battlemaster gossip on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.battlemaster end,
						set = function(val) self.db.profile.gos.battlemaster = val end,
					},
					all = {
						name = "all",
						desc = L["Toggles all gossips on/off."],
						type = "toggle",
						get = function() return self.db.profile.gos.all end,
						set = function(val) self.db.profile.gos.all = val end,
					}
				}
			}
		}
	}

	Denial2:RegisterChatCommand({ "/dnl", "/denial" }, options)
end

function Denial2:OnEnable()
	self:UnregisterAllEvents()
	if self.db.profile.block.party or self.db.profile.block.all then
		self:RegisterEvent("PARTY_INVITE_REQUEST", "BlockP")
	end
	if self.db.profile.block.duel or self.db.profile.block.all then
		self:RegisterEvent("DUEL_REQUESTED", "BlockD")
	end
	if self.db.profile.block.ginv or self.db.profile.block.all then
		self:RegisterEvent("GUILD_INVITE_REQUEST", "BlockG")
	end
	if self.db.profile.block.pet or self.db.profile.block.all then
		self:RegisterEvent("PETITION_SHOW", "Pet")
	end
	if self.db.profile.block.trade or self.db.profile.block.all then
		SetCVar("BlockTrades", "1")
	else
		SetCVar("BlockTrades")
	end
	self:RegisterEvent("GOSSIP_SHOW", "Smasher")
	self:RegisterEvent("GOSSIP_CLOSED")
end

function Denial2:BlockP()
	if self:IsFriend(arg1) or self.IsGuildie(arg1) then
		if self.db.profile.me then
			self:Print(L["Block has been ignored for Guildie/Friend: %s."], arg1)
		end
		return
	else
		HideUIPanel(StaticPopup1)
		DeclineGroup()
		self:BlockMsg(L["Party Invite"], who)
	end
end

function Denial2:BlockD()
	if self:IsFriend(arg1) or self:IsGuildie(arg1) then
		if self.db.profile.me then
			self:Print(L["Block has been ignored for Guildie/Friend: %s."], arg1)
		end
		return
	else
		HideUIPanel(StaticPopup1)
		CancelDuel()
		self:BlockMsg(L["Duel"], arg1)
	end
end

function Denial2:BlockG()
	if self:IsFriend(arg1) or self:IsGuildie(arg1) then
		if self.db.profile.me then
			self:Print(L["Block has been ignored for Guildie/Friend: %s."], arg1)
		end
		return
	else
		HideUIPanel(StaticPopup1)
		DeclineGuild()
		self:BlockMsg(L["Guild Invitation"], arg1, arg2)
	end
end

function Denial2:Pet()
	ClosePetition()
	if self.db.profile.me then
		self:Print(L["CHAT_INFO_CANCELED_NA"], L["Petition"])
	end
	self:IncCount()
end

function Denial2:Smasher()
	self.alpha = GossipFrame:GetAlpha()
	if (not IsControlKeyDown() and not (GetGossipAvailableQuests() or GetGossipActiveQuests())) then
		-- Sweet jeebus, it's sum h4x.
		GossipFrame:SetAlpha(0)
		local t = GetGossipText()
		if ((t == L["The orb's markings match the brand on your hand."]) or (t == L["Transport me to the Molten Core, Lothos."])) then
			SelectGossipOption(1)
			return
		end
		local g = {GetGossipOptions()}
		for v = 2, getn(g), 2 do
			if self.db.profile.gos[g[v]] then
				SelectGossipOption(v/2)
				return
			end
		end
		GossipFrame:SetAlpha(self.alpha)
	end
end

function Denial2:GOSSIP_CLOSED()
	-- Set alpha back to what it was before the h4x
	GossipFrame:SetAlpha(self.alpha)
end

function Denial2:IsFriend(name)
	for i=1,GetNumFriends() do
		if GetFriendInfo(i) == name then
			return true
		end
	end
end

function Denial2:IsGuildie(name)
	if IsInGuild() then
		for i=1, GetNumGuildMembers() do
			if GetGuildRosterInfo(i) == name then
				return true
			end
		end
	end
end

function Denial2:IncCount()
	self.db.profile.count = self.db.profile.count + 1
end

function Denial2:BlockMsg(what, who, guild)
	if self.db.profile.me then
		if guild then
			self:Print(L["GUILD_INFO_CANCELED"], what, guild, who)
		else
			self:Print(L["CHAT_INFO_CANCELED"], what, who)
		end
	end
	if self.db.profile.player then
		SendChatMessage("[Denial]: ".. self.db.profile.message, "WHISPER", GetDefaultLanguage("player"), who)
	end
	self:IncCount()
end
